/*____________________________________________________________________________
	Copyright (C) 1997-1999 Networks Associates Technology, Inc.
	All rights reserved.
	
	$Id: pgpSDKBuildFlags.h,v 1.16.2.1 2001/07/11 22:21:27 ajivsov Exp $
____________________________________________________________________________*/

#ifndef Included_pgpSDKBuildFlags_h	/* [ */
#define Included_pgpSDKBuildFlags_h

#ifdef OVERRIDE_BUILDFLAGS

#include "../../../../clients2/build/MastrBld.h"

#else
/*____________________________________________________________________________
	Algorithm support
____________________________________________________________________________*/

#define PGP_RSA				1
#define PGP_RSA_KEYGEN		1

#define PGP_USECAPIFORRSA	0	/* Try to use Microsoft CAPI library for RSA */
#define PGP_USECAPIFORMD2	0	/* Try to use Microsoft CAPI library for MD2 */
#define PGP_USEBSAFEFORRSA  0	/* Use RSA's BSAFE library for RSA support */
#define PGP_USEPGPFORRSA	1	/* Use the PGP implementation for RSA support */
#define PGP_USERSAREF		0	/* Use the non-commercial RSAREF library for RSA */

/* These probably will always be on */
#define PGP_CAST5		1
#define PGP_DES3		1
#define PGP_IDEA		1
#define PGP_TWOFISH		1
#define PGP_AES			1

/*____________________________________________________________________________
	Version information
____________________________________________________________________________*/

#define PGPSDK_SHORT_VERSION_STRING		"2.1a1"

#define PGPSDK_MAJOR_VERSION			2
#define PGPSDK_MINOR_VERSION			1
#define PGPSDK_SUBMINOR_VERSION			0
#define PGPSDK_RELEASE_STAGE			1	/* 0 = Development, 1 = Alpha, */
											/* 2 = Beta, 3 = Release */
#define PGPSDK_BUILD					1

#define PGPSDK_BUILDNUMBER				"224"
#define PGPSDK_INSTALLEDWITH			"PGP 7.0 (build 224 Beta)"

#define PGPCOMPANYNAME		"Networks Associates Technology, Inc."
#define PGPSDK_COPYRIGHT 	"Copyright (C) 2000 Networks Associates "\
							"Technology, Inc. All rights reserved."
#define PGPTRADEMARKS		"Network Associates, Pretty Good Privacy, " \
							"PGP"

/*____________________________________________________________________________
	Other optional flags
____________________________________________________________________________*/

#ifdef PGP_WIN32
	#define PGP_INTEL_RNG_SUPPORT	1
#else
	#define PGP_INTEL_RNG_SUPPORT	0
#endif

/* Allows turning off signing/verification capability in library */
#ifndef PGP_SIGN_DISABLE
	#define PGP_SIGN_DISABLE	0
#endif

#ifndef PGP_VERIFY_DISABLE
	#define PGP_VERIFY_DISABLE	0
#endif

/* Allows turning off encryption/decryption capability in library */
#ifndef PGP_ENCRYPT_DISABLE
	#define PGP_ENCRYPT_DISABLE	0
#endif

#ifndef PGP_DECRYPT_DISABLE
	#define PGP_DECRYPT_DISABLE	0
#endif

#endif /* OVERRIDE_BUILDFLAGS */

#endif /* ] Included_pgpSDKBuildFlags_h */


/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
